﻿Public Class Form1
    'グローバル変数を宣言
    'index  : ランダム取得する９つのマスの連番情報
    'count  : クリック成功した回数を保存
    'chance : 実行回数を保存
    'second : スタートボタンクリック後の経過秒数
    Dim index, count, chance, second As Integer
    'リソースファイル用のグローバル配列宣言
    Dim cdImages As Bitmap() = {My.Resources.CountDown3, My.Resources.CountDown2, My.Resources.CountDown1}

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        '結果表示用ラベルを非表示
        lblResult.Visible = False
        'スタートボタンを無効
        btnStart.Enabled = False

        'カウントダウン用pictureboxを表示し、カウントダウン用タイマー有効
        picCountDown.Visible = True
        picCountDown.BackgroundImage = Me.cdImages(Me.second)
        tmCountDown.Enabled = True
        '残り秒数を設置
        prbRemain.Value = prbRemain.Maximum
        lblRemain.Text = "残り" & (tmLimit.Interval / 1000) & "秒"

        '選択された難易度ごとに、tmTimerのIntervalプロパティを変更
        Select Case cmbDifficulty.SelectedIndex
            Case 0
                tmTimer.Interval = 1000
            Case 1
                tmTimer.Interval = 800
            Case 2
                tmTimer.Interval = 500
        End Select
    End Sub

    Private Sub tmTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmTimer.Tick
        'ランダムクラスを生成し変数rdmに代入
        Dim rdm As Random = New Random()
        '変数nxtidxを宣言
        Dim nxtidx As Integer = Me.index
        '変数nxtpic, nowpicを宣言
        Dim nxtpic, nowpic As PictureBox

        '背景色が変わったマスを初期化
        If Me.index <> 0 Then
            nowpic = DirectCast(pnlMain.Controls.Item("picMasu" & Me.index), PictureBox)
            nowpic.BackColor = Nothing
            nowpic.Enabled = False
        End If

        '連続して同じ乱数が発生しないようにする
        Do
            '1～9までの乱数をnxtidxへ代入
            nxtidx = rdm.Next(9) + 1
        Loop Until nxtidx <> Me.index

        'pnlMainのpicMasu1～9のいずれかをnxtpicへ代入
        nxtpic = DirectCast(pnlMain.Controls.Item("picMasu" & nxtidx), PictureBox)
        'ランダムに取得したpicMasuの背景色を黄色に変更
        nxtpic.BackColor = Color.Yellow
        nxtpic.Enabled = True
        nxtpic.Focus()

        Me.index = nxtidx
        '実行回数を数える
        Me.chance = Me.chance + 1
    End Sub

    Private Sub picMasus_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        'クリックしたマスをpicに代入
        Dim pic As PictureBox = DirectCast(sender, PictureBox)

        'クリック成功時は背景色を赤にし、無効にする
        pic.BackColor = Color.Red
        pic.Enabled = False

        'クリック成功数を数える
        Me.count = Me.count + 1
    End Sub

    Private Sub tmLimit_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmLimit.Tick
        '変数percentを宣言し、パーセント表示情報を設置
        Dim percent As Integer = Math.Floor(Me.count / Me.chance * 100)

        '各タイマーコントロールの無効化
        tmLimit.Enabled = False
        tmTimer.Enabled = False

        '結果表示ラベルに結果情報を設置
        lblResult.Text = Me.count & "／" & Me.chance & vbCrLf & vbCrLf & percent & "％"
        lblResult.Visible = True

        pnlMain.Visible = False
        btnStart.Enabled = True
        btnStart.Focus()

        '最後に実行状態になったマスを初期化
        Dim pic As PictureBox = DirectCast(pnlMain.Controls.Item("picMasu" & Me.index), PictureBox)
        pic.BackColor = Nothing
        pic.Enabled = False

        '経過秒数を0クリア
        Me.second = 0
        'カウントダウン用タイマーの無効化
        tmCountDown.Enabled = False
        '残り秒数の設置
        prbRemain.Value = 0
        lblRemain.Text = ""

    End Sub

    Private Sub picMasus_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        If (e.KeyCode = Keys.NumPad7 Or e.KeyCode = Keys.U) And Me.index = 1 Or _
            (e.KeyCode = Keys.NumPad8 Or e.KeyCode = Keys.I) And Me.index = 2 Or _
            (e.KeyCode = Keys.NumPad9 Or e.KeyCode = Keys.O) And Me.index = 3 Or _
            (e.KeyCode = Keys.NumPad4 Or e.KeyCode = Keys.J) And Me.index = 4 Or _
            (e.KeyCode = Keys.NumPad5 Or e.KeyCode = Keys.K) And Me.index = 5 Or _
            (e.KeyCode = Keys.NumPad6 Or e.KeyCode = Keys.L) And Me.index = 6 Or _
            (e.KeyCode = Keys.NumPad1 Or e.KeyCode = Keys.M) And Me.index = 7 Or _
            (e.KeyCode = Keys.NumPad2 Or e.KeyCode = Keys.Oemcomma) And Me.index = 8 Or _
            (e.KeyCode = Keys.NumPad3 Or e.KeyCode = Keys.OemPeriod) And Me.index = 9 Then

            'クリックイベント発生させる
            picMasus_Click(DirectCast(pnlMain.Controls.Item("picMasu" & Me.index), PictureBox), New EventArgs)
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim pic As PictureBox
        'サイズの生成
        Dim sz As Size = New Size(111, 96)
        Dim i As Integer

        For i = 0 To 8
            'PictureBoxの生成
            pic = New PictureBox

            'PictureBoxの設定
            pic.Name = "picMasu" & i + 1
            pic.Size = sz
            pic.BorderStyle = BorderStyle.FixedSingle
            pic.BackgroundImageLayout = ImageLayout.Center
            pic.Enabled = False
            pic.Location = New Point((i Mod 3) * 111, CInt(Math.Floor(i / 3)) * 96)

            'イベントの割り当て
            AddHandler pic.Click, AddressOf picMasus_Click
            AddHandler pic.KeyDown, AddressOf picMasus_KeyDown

            'pnlMainにコントロール追加し、グループ化
            pnlMain.Controls.Add(pic)
        Next

        Me.Controls.Add(picCountDown)
        pnlMain.Visible = False
        '難易度の初期値を初級に設置
        cmbDifficulty.SelectedIndex = 0
    End Sub

    Private Sub tmCountDown_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmCountDown.Tick
        Me.second = Me.second + 1

        If Me.second <= 2 Then
            'スタートボタンクリック後２秒内は、カウントダウンを表示
            picCountDown.BackgroundImage = Me.cdImages(Me.second)
        ElseIf Me.second = 3 Then
            'スタートボタンクリック後3秒目は、カウントダウンを表示
            picCountDown.Visible = False

            '９つのマス背景色ランダム変更用、
            '制限時間用タイマーコントロールの有効化
            tmTimer.Enabled = True
            tmLimit.Enabled = True
            btnStart.Enabled = False
            pnlMain.Visible = True

            'ゲーム情報の初期化
            Me.count = 0
            Me.chance = 0
            '0秒目のtmTimerチックイベントを発生させる
            tmTimer_Tick(tmTimer, New System.EventArgs)
        Else
            'スタートボタンクリック後4秒目以降は、1秒毎に残り秒数を設置
            prbRemain.Value = prbRemain.Maximum - ((Me.second - 3) * prbRemain.Maximum / (tmLimit.Interval / 1000))
            lblRemain.Text = "残り" & ((tmLimit.Interval / 1000) - (Me.second - 3)) & "秒"
        End If
    End Sub
End Class
